/*
 * This file was generated automatically by xsubpp version 1.9508 from the
 * contents of Bignum.xs. Do not edit this file, edit Bignum.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "Bignum.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include <openssl/err.h>
#include <openssl/bn.h>

#define checkOpenSslCall( result ) if( ! ( result ) ) \
  croak( "OpenSSL error: %s", ERR_reason_error_string( ERR_get_error() ) );

typedef BIGNUM *Crypt__OpenSSL__Bignum;
typedef BN_CTX *Crypt__OpenSSL__Bignum__CTX;

SV* new_obj( void* obj )
{
    SV * tmp = sv_newmortal();
    sv_setref_pv(tmp, "Crypt::OpenSSL::Bignum", (void*)obj);
    return tmp;
}

BIGNUM* sv2bn( SV* sv )
{
    if (SvROK(sv) && sv_derived_from(sv, "Crypt::OpenSSL::Bignum")) {
        return INT2PTR(Crypt__OpenSSL__Bignum, SvIV((SV*)SvRV(sv)));
    }
    else Perl_croak(aTHX_ "argument is not a Crypt::OpenSSL::Bignum object");
}

#line 39 "Bignum.c"

XS(XS_Crypt__OpenSSL__Bignum_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__Bignum_DESTROY)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Crypt::OpenSSL::Bignum::DESTROY(self)");
    {
	Crypt__OpenSSL__Bignum	self;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__OpenSSL__Bignum,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not a reference");
#line 37 "Bignum.xs"
        BN_clear_free( self );
#line 58 "Bignum.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Crypt__OpenSSL__Bignum_new_from_word); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__Bignum_new_from_word)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Crypt::OpenSSL::Bignum::new_from_word(CLASS, p_word)");
    {
	unsigned long	p_word = (unsigned long)SvUV(ST(1));
#line 43 "Bignum.xs"
    BIGNUM* bn;
#line 74 "Bignum.c"
	Crypt__OpenSSL__Bignum	RETVAL;
#line 45 "Bignum.xs"
    checkOpenSslCall( bn = BN_new() );
    checkOpenSslCall( BN_set_word( bn, p_word ) );
    RETVAL = bn;
#line 80 "Bignum.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Crypt::OpenSSL::Bignum", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__Bignum_new_from_decimal); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__Bignum_new_from_decimal)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Crypt::OpenSSL::Bignum::new_from_decimal(CLASS, p_dec_string)");
    {
	char*	p_dec_string = (char *)SvPV_nolen(ST(1));
#line 55 "Bignum.xs"
    BIGNUM* bn;
#line 98 "Bignum.c"
	Crypt__OpenSSL__Bignum	RETVAL;
#line 57 "Bignum.xs"
    bn = NULL;
    checkOpenSslCall( BN_dec2bn( &bn, p_dec_string ) );
    RETVAL = bn;
#line 104 "Bignum.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Crypt::OpenSSL::Bignum", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__Bignum_new_from_hex); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__Bignum_new_from_hex)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Crypt::OpenSSL::Bignum::new_from_hex(CLASS, p_hex_string)");
    {
	char*	p_hex_string = (char *)SvPV_nolen(ST(1));
#line 67 "Bignum.xs"
    BIGNUM* bn;
#line 122 "Bignum.c"
	Crypt__OpenSSL__Bignum	RETVAL;
#line 69 "Bignum.xs"
    bn = NULL;
    checkOpenSslCall( BN_hex2bn( &bn, p_hex_string ) );
    RETVAL = bn;
#line 128 "Bignum.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Crypt::OpenSSL::Bignum", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__Bignum_new_from_bin); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__Bignum_new_from_bin)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Crypt::OpenSSL::Bignum::new_from_bin(CLASS, p_bin_string_SV)");
    {
	SV*	p_bin_string_SV = ST(1);
#line 79 "Bignum.xs"
    BIGNUM* bn;
    unsigned char* bin;
    STRLEN bin_length;
#line 148 "Bignum.c"
	Crypt__OpenSSL__Bignum	RETVAL;
#line 83 "Bignum.xs"
    bin = (unsigned char*) SvPV( p_bin_string_SV, bin_length );
    checkOpenSslCall( bn = BN_bin2bn( bin, bin_length, NULL ) );
    RETVAL = bn;
#line 154 "Bignum.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Crypt::OpenSSL::Bignum", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__Bignum_new); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__Bignum_new)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Crypt::OpenSSL::Bignum::new(CLASS)");
    {
#line 92 "Bignum.xs"
    BIGNUM* bn;
#line 171 "Bignum.c"
	Crypt__OpenSSL__Bignum	RETVAL;
#line 94 "Bignum.xs"
    checkOpenSslCall( bn = BN_new() );
    checkOpenSslCall( BN_zero( bn ) );
    RETVAL = bn;
#line 177 "Bignum.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Crypt::OpenSSL::Bignum", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__Bignum_zero); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__Bignum_zero)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Crypt::OpenSSL::Bignum::zero(CLASS)");
    {
#line 103 "Bignum.xs"
    BIGNUM *bn;
#line 194 "Bignum.c"
	Crypt__OpenSSL__Bignum	RETVAL;
#line 105 "Bignum.xs"
    checkOpenSslCall( bn = BN_new() );
    checkOpenSslCall( BN_zero( bn ) );
    RETVAL = bn;
#line 200 "Bignum.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Crypt::OpenSSL::Bignum", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__Bignum_one); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__Bignum_one)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Crypt::OpenSSL::Bignum::one(CLASS)");
    {
#line 114 "Bignum.xs"
    BIGNUM *bn;
#line 217 "Bignum.c"
	Crypt__OpenSSL__Bignum	RETVAL;
#line 116 "Bignum.xs"
    checkOpenSslCall( bn = BN_new() );
    checkOpenSslCall( BN_one( bn ) );
    RETVAL = bn;
#line 223 "Bignum.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Crypt::OpenSSL::Bignum", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__Bignum_rand); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__Bignum_rand)
{
    dXSARGS;
    if (items != 4)
	Perl_croak(aTHX_ "Usage: Crypt::OpenSSL::Bignum::rand(CLASS, bits, top, bottom)");
    {
#line 125 "Bignum.xs"
    BIGNUM* bn;
#line 240 "Bignum.c"
	Crypt__OpenSSL__Bignum	RETVAL;
	int	bits = (int)SvIV(ST(1));
	int	top = (int)SvIV(ST(2));
	int	bottom = (int)SvIV(ST(3));
#line 127 "Bignum.xs"
    checkOpenSslCall( bn = BN_new() );
    checkOpenSslCall( BN_rand( bn, bits, top, bottom) );
    RETVAL = bn;
#line 249 "Bignum.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Crypt::OpenSSL::Bignum", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__Bignum_pseudo_rand); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__Bignum_pseudo_rand)
{
    dXSARGS;
    if (items != 4)
	Perl_croak(aTHX_ "Usage: Crypt::OpenSSL::Bignum::pseudo_rand(CLASS, bits, top, bottom)");
    {
#line 136 "Bignum.xs"
    BIGNUM* bn;
#line 266 "Bignum.c"
	Crypt__OpenSSL__Bignum	RETVAL;
	int	bits = (int)SvIV(ST(1));
	int	top = (int)SvIV(ST(2));
	int	bottom = (int)SvIV(ST(3));
#line 138 "Bignum.xs"
    checkOpenSslCall( bn = BN_new() );
    checkOpenSslCall( BN_pseudo_rand( bn, bits, top, bottom) );
    RETVAL = bn;
#line 275 "Bignum.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Crypt::OpenSSL::Bignum", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__Bignum_rand_range); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__Bignum_rand_range)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Crypt::OpenSSL::Bignum::rand_range(CLASS, r)");
    {
#line 147 "Bignum.xs"
    BIGNUM* bn;
#line 292 "Bignum.c"
	Crypt__OpenSSL__Bignum	RETVAL;
	Crypt__OpenSSL__Bignum	r;

	if (sv_derived_from(ST(1), "Crypt::OpenSSL::Bignum")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    r = INT2PTR(Crypt__OpenSSL__Bignum,tmp);
	}
	else
	    Perl_croak(aTHX_ "r is not of type Crypt::OpenSSL::Bignum");
#line 149 "Bignum.xs"
    checkOpenSslCall( bn = BN_new() );
    checkOpenSslCall( BN_rand_range( bn, r) );
    RETVAL = bn;
#line 306 "Bignum.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Crypt::OpenSSL::Bignum", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__Bignum_bless_pointer); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__Bignum_bless_pointer)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Crypt::OpenSSL::Bignum::bless_pointer(CLASS, pointer)");
    SP -= items;
    {
	void *	pointer = INT2PTR(void *,SvIV(ST(1)));
#line 158 "Bignum.xs"
    ST(0) = new_obj(pointer);
    XSRETURN(1);
#line 326 "Bignum.c"
	PUTBACK;
	return;
    }
}


XS(XS_Crypt__OpenSSL__Bignum_to_decimal); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__Bignum_to_decimal)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Crypt::OpenSSL::Bignum::to_decimal(self)");
    {
	char *	RETVAL;
	dXSTARG;
	Crypt__OpenSSL__Bignum	self;

	if (sv_derived_from(ST(0), "Crypt::OpenSSL::Bignum")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__OpenSSL__Bignum,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not of type Crypt::OpenSSL::Bignum");
#line 164 "Bignum.xs"
    checkOpenSslCall( RETVAL = BN_bn2dec( self ) );
#line 352 "Bignum.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
#line 168 "Bignum.xs"
    OPENSSL_free( RETVAL );
#line 356 "Bignum.c"
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__Bignum_to_hex); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__Bignum_to_hex)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Crypt::OpenSSL::Bignum::to_hex(self)");
    {
	char *	RETVAL;
	dXSTARG;
	Crypt__OpenSSL__Bignum	self;

	if (sv_derived_from(ST(0), "Crypt::OpenSSL::Bignum")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__OpenSSL__Bignum,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not of type Crypt::OpenSSL::Bignum");
#line 173 "Bignum.xs"
    checkOpenSslCall( RETVAL = BN_bn2hex( self ) );
#line 381 "Bignum.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
#line 177 "Bignum.xs"
    OPENSSL_free( RETVAL );
#line 385 "Bignum.c"
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__Bignum_to_bin); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__Bignum_to_bin)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Crypt::OpenSSL::Bignum::to_bin(self)");
    {
#line 182 "Bignum.xs"
    unsigned char* bin;
    int length;
#line 401 "Bignum.c"
	SV *	RETVAL;
	Crypt__OpenSSL__Bignum	self;

	if (sv_derived_from(ST(0), "Crypt::OpenSSL::Bignum")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__OpenSSL__Bignum,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not of type Crypt::OpenSSL::Bignum");
#line 185 "Bignum.xs"
    length = BN_num_bytes( self );
    if (length>0) {
      RETVAL = NEWSV(0, length);
      SvPOK_only(RETVAL);
      SvCUR_set(RETVAL, length);
      bin = (unsigned char *)SvPV_nolen(RETVAL);
      BN_bn2bin( self, bin );
    }
    else {
      RETVAL = newSVpvn("", 0);
    }
#line 423 "Bignum.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__Bignum_get_word); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__Bignum_get_word)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Crypt::OpenSSL::Bignum::get_word(self)");
    {
	unsigned long	RETVAL;
	dXSTARG;
	Crypt__OpenSSL__Bignum	self;

	if (sv_derived_from(ST(0), "Crypt::OpenSSL::Bignum")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__OpenSSL__Bignum,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not of type Crypt::OpenSSL::Bignum");

	RETVAL = BN_get_word(self);
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__Bignum_is_zero); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__Bignum_is_zero)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Crypt::OpenSSL::Bignum::is_zero(self)");
    {
	int	RETVAL;
	dXSTARG;
	Crypt__OpenSSL__Bignum	self;

	if (sv_derived_from(ST(0), "Crypt::OpenSSL::Bignum")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__OpenSSL__Bignum,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not of type Crypt::OpenSSL::Bignum");

	RETVAL = BN_is_zero(self);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__Bignum_is_one); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__Bignum_is_one)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Crypt::OpenSSL::Bignum::is_one(self)");
    {
	int	RETVAL;
	dXSTARG;
	Crypt__OpenSSL__Bignum	self;

	if (sv_derived_from(ST(0), "Crypt::OpenSSL::Bignum")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__OpenSSL__Bignum,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not of type Crypt::OpenSSL::Bignum");

	RETVAL = BN_is_one(self);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__Bignum_is_odd); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__Bignum_is_odd)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Crypt::OpenSSL::Bignum::is_odd(self)");
    {
	int	RETVAL;
	dXSTARG;
	Crypt__OpenSSL__Bignum	self;

	if (sv_derived_from(ST(0), "Crypt::OpenSSL::Bignum")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__OpenSSL__Bignum,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not of type Crypt::OpenSSL::Bignum");

	RETVAL = BN_is_odd(self);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__Bignum_add); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__Bignum_add)
{
    dXSARGS;
    if (items < 2)
	Perl_croak(aTHX_ "Usage: Crypt::OpenSSL::Bignum::add(self, b, ...)");
    SP -= items;
    {
#line 214 "Bignum.xs"
    BIGNUM *bn;
#line 541 "Bignum.c"
	Crypt__OpenSSL__Bignum	self;
	Crypt__OpenSSL__Bignum	b;

	if (sv_derived_from(ST(0), "Crypt::OpenSSL::Bignum")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__OpenSSL__Bignum,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not of type Crypt::OpenSSL::Bignum");

	if (sv_derived_from(ST(1), "Crypt::OpenSSL::Bignum")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    b = INT2PTR(Crypt__OpenSSL__Bignum,tmp);
	}
	else
	    Perl_croak(aTHX_ "b is not of type Crypt::OpenSSL::Bignum");
#line 216 "Bignum.xs"
    if( items > 3 )
      croak( "usage: $bn->add( $bn2[, $target] )" );
    bn = ( items < 3 ) ? BN_new() : sv2bn( ST(2) );
    checkOpenSslCall( BN_add( bn, self, b ) );
    ST(0) = ( (items < 3 ) ? new_obj( bn ) : ST(2) );
    XSRETURN(1);
#line 565 "Bignum.c"
	PUTBACK;
	return;
    }
}


XS(XS_Crypt__OpenSSL__Bignum_sub); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__Bignum_sub)
{
    dXSARGS;
    if (items < 2)
	Perl_croak(aTHX_ "Usage: Crypt::OpenSSL::Bignum::sub(self, b, ...)");
    SP -= items;
    {
#line 226 "Bignum.xs"
    BIGNUM *bn;
#line 582 "Bignum.c"
	Crypt__OpenSSL__Bignum	self;
	Crypt__OpenSSL__Bignum	b;

	if (sv_derived_from(ST(0), "Crypt::OpenSSL::Bignum")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__OpenSSL__Bignum,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not of type Crypt::OpenSSL::Bignum");

	if (sv_derived_from(ST(1), "Crypt::OpenSSL::Bignum")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    b = INT2PTR(Crypt__OpenSSL__Bignum,tmp);
	}
	else
	    Perl_croak(aTHX_ "b is not of type Crypt::OpenSSL::Bignum");
#line 228 "Bignum.xs"
    if( items > 3 )
      croak( "usage: $bn->sub( $bn2[, $target] )" );
    bn = ( items < 3 ) ? BN_new() : sv2bn( ST(2) );
    checkOpenSslCall( BN_sub( bn, self, b ) );
    ST(0) = ( (items < 3 ) ? new_obj( bn ) : ST(2) );
    XSRETURN(1);
#line 606 "Bignum.c"
	PUTBACK;
	return;
    }
}


XS(XS_Crypt__OpenSSL__Bignum_mul); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__Bignum_mul)
{
    dXSARGS;
    if (items < 3)
	Perl_croak(aTHX_ "Usage: Crypt::OpenSSL::Bignum::mul(self, b, ctx, ...)");
    SP -= items;
    {
	Crypt__OpenSSL__Bignum	self;
	Crypt__OpenSSL__Bignum	b;
	Crypt__OpenSSL__Bignum__CTX	ctx;
#line 241 "Bignum.xs"
    BIGNUM* bn;
#line 626 "Bignum.c"

	if (sv_derived_from(ST(0), "Crypt::OpenSSL::Bignum")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__OpenSSL__Bignum,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not of type Crypt::OpenSSL::Bignum");

	if (sv_derived_from(ST(1), "Crypt::OpenSSL::Bignum")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    b = INT2PTR(Crypt__OpenSSL__Bignum,tmp);
	}
	else
	    Perl_croak(aTHX_ "b is not of type Crypt::OpenSSL::Bignum");

	if (sv_derived_from(ST(2), "Crypt::OpenSSL::Bignum::CTX")) {
	    IV tmp = SvIV((SV*)SvRV(ST(2)));
	    ctx = INT2PTR(Crypt__OpenSSL__Bignum__CTX,tmp);
	}
	else
	    Perl_croak(aTHX_ "ctx is not of type Crypt::OpenSSL::Bignum::CTX");
#line 243 "Bignum.xs"
    if( items > 4 )
      croak( "usage: $bn->mul( $bn2, $ctx, [, $target] )" );
    bn = ( items < 4 ) ? BN_new() : sv2bn( ST(3) );
    checkOpenSslCall( BN_mul( bn, self, b, ctx ) );
    ST(0) = ( (items < 4 ) ? new_obj( bn ) : ST(3) );
    XSRETURN(1);
#line 655 "Bignum.c"
	PUTBACK;
	return;
    }
}


XS(XS_Crypt__OpenSSL__Bignum_div); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__Bignum_div)
{
    dXSARGS;
    if (items < 3)
	Perl_croak(aTHX_ "Usage: Crypt::OpenSSL::Bignum::div(self, b, ctx, ...)");
    SP -= items;
    {
	Crypt__OpenSSL__Bignum	self;
	Crypt__OpenSSL__Bignum	b;
	Crypt__OpenSSL__Bignum__CTX	ctx;
#line 256 "Bignum.xs"
    BIGNUM* quotient;
    BIGNUM* remainder;
#line 676 "Bignum.c"

	if (sv_derived_from(ST(0), "Crypt::OpenSSL::Bignum")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__OpenSSL__Bignum,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not of type Crypt::OpenSSL::Bignum");

	if (sv_derived_from(ST(1), "Crypt::OpenSSL::Bignum")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    b = INT2PTR(Crypt__OpenSSL__Bignum,tmp);
	}
	else
	    Perl_croak(aTHX_ "b is not of type Crypt::OpenSSL::Bignum");

	if (sv_derived_from(ST(2), "Crypt::OpenSSL::Bignum::CTX")) {
	    IV tmp = SvIV((SV*)SvRV(ST(2)));
	    ctx = INT2PTR(Crypt__OpenSSL__Bignum__CTX,tmp);
	}
	else
	    Perl_croak(aTHX_ "ctx is not of type Crypt::OpenSSL::Bignum::CTX");
#line 259 "Bignum.xs"
    if( items > 5 )
      croak( "usage: $bn->div( $bn2, $ctx, [, $quotient [, $remainder ] ] )" );
    quotient = ( items < 4 ) ? BN_new() : sv2bn( ST(3) );
    remainder = ( items < 5 ) ? BN_new() : sv2bn( ST(4) );
    checkOpenSslCall( BN_div( quotient, remainder, self, b, ctx ) );
    ST(0) = ( (items < 4 ) ? new_obj( quotient ) : ST(3) );
    ST(1) = ( (items < 5 ) ? new_obj( remainder ) : ST(4) );
    XSRETURN(2);
#line 707 "Bignum.c"
	PUTBACK;
	return;
    }
}


XS(XS_Crypt__OpenSSL__Bignum_sqr); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__Bignum_sqr)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Crypt::OpenSSL::Bignum::sqr(self, ctx)");
    {
#line 271 "Bignum.xs"
    BIGNUM* bn;
#line 723 "Bignum.c"
	Crypt__OpenSSL__Bignum	RETVAL;
	Crypt__OpenSSL__Bignum	self;
	Crypt__OpenSSL__Bignum__CTX	ctx;

	if (sv_derived_from(ST(0), "Crypt::OpenSSL::Bignum")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__OpenSSL__Bignum,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not of type Crypt::OpenSSL::Bignum");

	if (sv_derived_from(ST(1), "Crypt::OpenSSL::Bignum::CTX")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    ctx = INT2PTR(Crypt__OpenSSL__Bignum__CTX,tmp);
	}
	else
	    Perl_croak(aTHX_ "ctx is not of type Crypt::OpenSSL::Bignum::CTX");
#line 273 "Bignum.xs"
    checkOpenSslCall( bn = BN_new() );
    checkOpenSslCall( BN_sqr( bn, self, ctx ) );
    RETVAL = bn;
#line 745 "Bignum.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Crypt::OpenSSL::Bignum", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__Bignum_mod); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__Bignum_mod)
{
    dXSARGS;
    if (items < 3)
	Perl_croak(aTHX_ "Usage: Crypt::OpenSSL::Bignum::mod(self, b, ctx, ...)");
    SP -= items;
    {
	Crypt__OpenSSL__Bignum	self;
	Crypt__OpenSSL__Bignum	b;
	Crypt__OpenSSL__Bignum__CTX	ctx;
#line 285 "Bignum.xs"
    BIGNUM* bn;
#line 766 "Bignum.c"

	if (sv_derived_from(ST(0), "Crypt::OpenSSL::Bignum")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__OpenSSL__Bignum,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not of type Crypt::OpenSSL::Bignum");

	if (sv_derived_from(ST(1), "Crypt::OpenSSL::Bignum")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    b = INT2PTR(Crypt__OpenSSL__Bignum,tmp);
	}
	else
	    Perl_croak(aTHX_ "b is not of type Crypt::OpenSSL::Bignum");

	if (sv_derived_from(ST(2), "Crypt::OpenSSL::Bignum::CTX")) {
	    IV tmp = SvIV((SV*)SvRV(ST(2)));
	    ctx = INT2PTR(Crypt__OpenSSL__Bignum__CTX,tmp);
	}
	else
	    Perl_croak(aTHX_ "ctx is not of type Crypt::OpenSSL::Bignum::CTX");
#line 287 "Bignum.xs"
    if( items > 4 )
      croak( "usage: $bn->mod( $bn2, $ctx, [, $target] )" );
    bn = ( items < 4 ) ? BN_new() : sv2bn( ST(3) );
    checkOpenSslCall( BN_mod( bn, self, b, ctx ) );
    ST(0) = ( (items < 4 ) ? new_obj( bn ) : ST(3) );
    XSRETURN(1);
#line 795 "Bignum.c"
	PUTBACK;
	return;
    }
}


XS(XS_Crypt__OpenSSL__Bignum_mod_mul); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__Bignum_mod_mul)
{
    dXSARGS;
    if (items != 4)
	Perl_croak(aTHX_ "Usage: Crypt::OpenSSL::Bignum::mod_mul(self, b, m, ctx)");
    {
	Crypt__OpenSSL__Bignum	self;
	Crypt__OpenSSL__Bignum	b;
	Crypt__OpenSSL__Bignum	m;
	Crypt__OpenSSL__Bignum__CTX	ctx;
#line 301 "Bignum.xs"
    BIGNUM* bn;
#line 815 "Bignum.c"
	Crypt__OpenSSL__Bignum	RETVAL;

	if (sv_derived_from(ST(0), "Crypt::OpenSSL::Bignum")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__OpenSSL__Bignum,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not of type Crypt::OpenSSL::Bignum");

	if (sv_derived_from(ST(1), "Crypt::OpenSSL::Bignum")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    b = INT2PTR(Crypt__OpenSSL__Bignum,tmp);
	}
	else
	    Perl_croak(aTHX_ "b is not of type Crypt::OpenSSL::Bignum");

	if (sv_derived_from(ST(2), "Crypt::OpenSSL::Bignum")) {
	    IV tmp = SvIV((SV*)SvRV(ST(2)));
	    m = INT2PTR(Crypt__OpenSSL__Bignum,tmp);
	}
	else
	    Perl_croak(aTHX_ "m is not of type Crypt::OpenSSL::Bignum");

	if (sv_derived_from(ST(3), "Crypt::OpenSSL::Bignum::CTX")) {
	    IV tmp = SvIV((SV*)SvRV(ST(3)));
	    ctx = INT2PTR(Crypt__OpenSSL__Bignum__CTX,tmp);
	}
	else
	    Perl_croak(aTHX_ "ctx is not of type Crypt::OpenSSL::Bignum::CTX");
#line 303 "Bignum.xs"
    checkOpenSslCall( bn = BN_new() );
    checkOpenSslCall( BN_mod_mul( bn, self, b, m, ctx ) );
    RETVAL = bn;
#line 849 "Bignum.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Crypt::OpenSSL::Bignum", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__Bignum_exp); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__Bignum_exp)
{
    dXSARGS;
    if (items != 3)
	Perl_croak(aTHX_ "Usage: Crypt::OpenSSL::Bignum::exp(self, exp, ctx)");
    {
	Crypt__OpenSSL__Bignum	self;
	Crypt__OpenSSL__Bignum	exp;
	Crypt__OpenSSL__Bignum__CTX	ctx;
#line 315 "Bignum.xs"
    BIGNUM* bn;
#line 869 "Bignum.c"
	Crypt__OpenSSL__Bignum	RETVAL;

	if (sv_derived_from(ST(0), "Crypt::OpenSSL::Bignum")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__OpenSSL__Bignum,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not of type Crypt::OpenSSL::Bignum");

	if (sv_derived_from(ST(1), "Crypt::OpenSSL::Bignum")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    exp = INT2PTR(Crypt__OpenSSL__Bignum,tmp);
	}
	else
	    Perl_croak(aTHX_ "exp is not of type Crypt::OpenSSL::Bignum");

	if (sv_derived_from(ST(2), "Crypt::OpenSSL::Bignum::CTX")) {
	    IV tmp = SvIV((SV*)SvRV(ST(2)));
	    ctx = INT2PTR(Crypt__OpenSSL__Bignum__CTX,tmp);
	}
	else
	    Perl_croak(aTHX_ "ctx is not of type Crypt::OpenSSL::Bignum::CTX");
#line 317 "Bignum.xs"
    checkOpenSslCall( bn = BN_new() );
    checkOpenSslCall( BN_exp( bn, self, exp, ctx ) );
    RETVAL = bn;
#line 896 "Bignum.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Crypt::OpenSSL::Bignum", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__Bignum_mod_exp); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__Bignum_mod_exp)
{
    dXSARGS;
    if (items != 4)
	Perl_croak(aTHX_ "Usage: Crypt::OpenSSL::Bignum::mod_exp(self, exp, mod, ctx)");
    {
	Crypt__OpenSSL__Bignum	self;
	Crypt__OpenSSL__Bignum	exp;
	Crypt__OpenSSL__Bignum	mod;
	Crypt__OpenSSL__Bignum__CTX	ctx;
#line 330 "Bignum.xs"
    BIGNUM* bn;
#line 917 "Bignum.c"
	Crypt__OpenSSL__Bignum	RETVAL;

	if (sv_derived_from(ST(0), "Crypt::OpenSSL::Bignum")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__OpenSSL__Bignum,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not of type Crypt::OpenSSL::Bignum");

	if (sv_derived_from(ST(1), "Crypt::OpenSSL::Bignum")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    exp = INT2PTR(Crypt__OpenSSL__Bignum,tmp);
	}
	else
	    Perl_croak(aTHX_ "exp is not of type Crypt::OpenSSL::Bignum");

	if (sv_derived_from(ST(2), "Crypt::OpenSSL::Bignum")) {
	    IV tmp = SvIV((SV*)SvRV(ST(2)));
	    mod = INT2PTR(Crypt__OpenSSL__Bignum,tmp);
	}
	else
	    Perl_croak(aTHX_ "mod is not of type Crypt::OpenSSL::Bignum");

	if (sv_derived_from(ST(3), "Crypt::OpenSSL::Bignum::CTX")) {
	    IV tmp = SvIV((SV*)SvRV(ST(3)));
	    ctx = INT2PTR(Crypt__OpenSSL__Bignum__CTX,tmp);
	}
	else
	    Perl_croak(aTHX_ "ctx is not of type Crypt::OpenSSL::Bignum::CTX");
#line 332 "Bignum.xs"
    checkOpenSslCall( bn = BN_new() );
    checkOpenSslCall( BN_mod_exp( bn, self, exp, mod, ctx ) );
    RETVAL = bn;
#line 951 "Bignum.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Crypt::OpenSSL::Bignum", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__Bignum_mod_inverse); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__Bignum_mod_inverse)
{
    dXSARGS;
    if (items != 3)
	Perl_croak(aTHX_ "Usage: Crypt::OpenSSL::Bignum::mod_inverse(self, n, ctx)");
    {
	Crypt__OpenSSL__Bignum	self;
	Crypt__OpenSSL__Bignum	n;
	Crypt__OpenSSL__Bignum__CTX	ctx;
#line 344 "Bignum.xs"
    BIGNUM* bn;
#line 971 "Bignum.c"
	Crypt__OpenSSL__Bignum	RETVAL;

	if (sv_derived_from(ST(0), "Crypt::OpenSSL::Bignum")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__OpenSSL__Bignum,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not of type Crypt::OpenSSL::Bignum");

	if (sv_derived_from(ST(1), "Crypt::OpenSSL::Bignum")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    n = INT2PTR(Crypt__OpenSSL__Bignum,tmp);
	}
	else
	    Perl_croak(aTHX_ "n is not of type Crypt::OpenSSL::Bignum");

	if (sv_derived_from(ST(2), "Crypt::OpenSSL::Bignum::CTX")) {
	    IV tmp = SvIV((SV*)SvRV(ST(2)));
	    ctx = INT2PTR(Crypt__OpenSSL__Bignum__CTX,tmp);
	}
	else
	    Perl_croak(aTHX_ "ctx is not of type Crypt::OpenSSL::Bignum::CTX");
#line 346 "Bignum.xs"
    checkOpenSslCall( bn = BN_new() );
    checkOpenSslCall( BN_mod_inverse( bn, self, n, ctx ) );
    RETVAL = bn;
#line 998 "Bignum.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Crypt::OpenSSL::Bignum", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__Bignum_gcd); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__Bignum_gcd)
{
    dXSARGS;
    if (items != 3)
	Perl_croak(aTHX_ "Usage: Crypt::OpenSSL::Bignum::gcd(self, b, ctx)");
    {
	Crypt__OpenSSL__Bignum	self;
	Crypt__OpenSSL__Bignum	b;
	Crypt__OpenSSL__Bignum__CTX	ctx;
#line 358 "Bignum.xs"
    BIGNUM* bn;
#line 1018 "Bignum.c"
	Crypt__OpenSSL__Bignum	RETVAL;

	if (sv_derived_from(ST(0), "Crypt::OpenSSL::Bignum")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__OpenSSL__Bignum,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not of type Crypt::OpenSSL::Bignum");

	if (sv_derived_from(ST(1), "Crypt::OpenSSL::Bignum")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    b = INT2PTR(Crypt__OpenSSL__Bignum,tmp);
	}
	else
	    Perl_croak(aTHX_ "b is not of type Crypt::OpenSSL::Bignum");

	if (sv_derived_from(ST(2), "Crypt::OpenSSL::Bignum::CTX")) {
	    IV tmp = SvIV((SV*)SvRV(ST(2)));
	    ctx = INT2PTR(Crypt__OpenSSL__Bignum__CTX,tmp);
	}
	else
	    Perl_croak(aTHX_ "ctx is not of type Crypt::OpenSSL::Bignum::CTX");
#line 360 "Bignum.xs"
    checkOpenSslCall( bn = BN_new() );
    checkOpenSslCall( BN_gcd( bn, self, b, ctx ) );
    RETVAL = bn;
#line 1045 "Bignum.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Crypt::OpenSSL::Bignum", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__Bignum_equals); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__Bignum_equals)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Crypt::OpenSSL::Bignum::equals(self, b)");
    {
	int	RETVAL;
	dXSTARG;
	Crypt__OpenSSL__Bignum	self;
	Crypt__OpenSSL__Bignum	b;

	if (sv_derived_from(ST(0), "Crypt::OpenSSL::Bignum")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__OpenSSL__Bignum,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not of type Crypt::OpenSSL::Bignum");

	if (sv_derived_from(ST(1), "Crypt::OpenSSL::Bignum")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    b = INT2PTR(Crypt__OpenSSL__Bignum,tmp);
	}
	else
	    Perl_croak(aTHX_ "b is not of type Crypt::OpenSSL::Bignum");
#line 369 "Bignum.xs"
    RETVAL = BN_cmp(self, b) == 0 ? 1 : 0;
#line 1080 "Bignum.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__Bignum_cmp); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__Bignum_cmp)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Crypt::OpenSSL::Bignum::cmp(self, b)");
    {
	int	RETVAL;
	dXSTARG;
	Crypt__OpenSSL__Bignum	self;
	Crypt__OpenSSL__Bignum	b;

	if (sv_derived_from(ST(0), "Crypt::OpenSSL::Bignum")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__OpenSSL__Bignum,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not of type Crypt::OpenSSL::Bignum");

	if (sv_derived_from(ST(1), "Crypt::OpenSSL::Bignum")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    b = INT2PTR(Crypt__OpenSSL__Bignum,tmp);
	}
	else
	    Perl_croak(aTHX_ "b is not of type Crypt::OpenSSL::Bignum");

	RETVAL = BN_cmp(self, b);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__Bignum_num_bits); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__Bignum_num_bits)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Crypt::OpenSSL::Bignum::num_bits(self)");
    {
	int	RETVAL;
	dXSTARG;
	Crypt__OpenSSL__Bignum	self;

	if (sv_derived_from(ST(0), "Crypt::OpenSSL::Bignum")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__OpenSSL__Bignum,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not of type Crypt::OpenSSL::Bignum");

	RETVAL = BN_num_bits(self);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__Bignum_num_bytes); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__Bignum_num_bytes)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Crypt::OpenSSL::Bignum::num_bytes(self)");
    {
	int	RETVAL;
	dXSTARG;
	Crypt__OpenSSL__Bignum	self;

	if (sv_derived_from(ST(0), "Crypt::OpenSSL::Bignum")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__OpenSSL__Bignum,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not of type Crypt::OpenSSL::Bignum");

	RETVAL = BN_num_bytes(self);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__Bignum_rshift); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__Bignum_rshift)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Crypt::OpenSSL::Bignum::rshift(self, n)");
    {
#line 385 "Bignum.xs"
    BIGNUM* bn;
#line 1179 "Bignum.c"
	Crypt__OpenSSL__Bignum	RETVAL;
	Crypt__OpenSSL__Bignum	self;
	int	n = (int)SvIV(ST(1));

	if (sv_derived_from(ST(0), "Crypt::OpenSSL::Bignum")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__OpenSSL__Bignum,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not of type Crypt::OpenSSL::Bignum");
#line 387 "Bignum.xs"
    checkOpenSslCall( bn = BN_new() );
    checkOpenSslCall( BN_rshift( bn, self, n ) );
    RETVAL = bn;
#line 1194 "Bignum.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Crypt::OpenSSL::Bignum", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__Bignum_lshift); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__Bignum_lshift)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Crypt::OpenSSL::Bignum::lshift(self, n)");
    {
#line 396 "Bignum.xs"
    BIGNUM* bn;
#line 1211 "Bignum.c"
	Crypt__OpenSSL__Bignum	RETVAL;
	Crypt__OpenSSL__Bignum	self;
	int	n = (int)SvIV(ST(1));

	if (sv_derived_from(ST(0), "Crypt::OpenSSL::Bignum")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__OpenSSL__Bignum,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not of type Crypt::OpenSSL::Bignum");
#line 398 "Bignum.xs"
    checkOpenSslCall( bn = BN_new() );
    checkOpenSslCall( BN_lshift( bn, self, n ) );
    RETVAL = bn;
#line 1226 "Bignum.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Crypt::OpenSSL::Bignum", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__Bignum_ucmp); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__Bignum_ucmp)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Crypt::OpenSSL::Bignum::ucmp(self, b)");
    {
	int	RETVAL;
	dXSTARG;
	Crypt__OpenSSL__Bignum	self;
	Crypt__OpenSSL__Bignum	b;

	if (sv_derived_from(ST(0), "Crypt::OpenSSL::Bignum")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__OpenSSL__Bignum,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not of type Crypt::OpenSSL::Bignum");

	if (sv_derived_from(ST(1), "Crypt::OpenSSL::Bignum")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    b = INT2PTR(Crypt__OpenSSL__Bignum,tmp);
	}
	else
	    Perl_croak(aTHX_ "b is not of type Crypt::OpenSSL::Bignum");

	RETVAL = BN_ucmp(self, b);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__Bignum_swap); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__Bignum_swap)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: Crypt::OpenSSL::Bignum::swap(self, b)");
    {
	Crypt__OpenSSL__Bignum	self;
	Crypt__OpenSSL__Bignum	b;

	if (sv_derived_from(ST(0), "Crypt::OpenSSL::Bignum")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__OpenSSL__Bignum,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not of type Crypt::OpenSSL::Bignum");

	if (sv_derived_from(ST(1), "Crypt::OpenSSL::Bignum")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    b = INT2PTR(Crypt__OpenSSL__Bignum,tmp);
	}
	else
	    Perl_croak(aTHX_ "b is not of type Crypt::OpenSSL::Bignum");

	BN_swap(self, b);
    }
    XSRETURN_EMPTY;
}


XS(XS_Crypt__OpenSSL__Bignum_copy); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__Bignum_copy)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Crypt::OpenSSL::Bignum::copy(self)");
    {
	Crypt__OpenSSL__Bignum	RETVAL;
	Crypt__OpenSSL__Bignum	self;

	if (sv_derived_from(ST(0), "Crypt::OpenSSL::Bignum")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__OpenSSL__Bignum,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not of type Crypt::OpenSSL::Bignum");
#line 413 "Bignum.xs"
    checkOpenSslCall( RETVAL = BN_dup(self) );
#line 1315 "Bignum.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Crypt::OpenSSL::Bignum", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__Bignum_pointer_copy); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__Bignum_pointer_copy)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Crypt::OpenSSL::Bignum::pointer_copy(self)");
    {
	IV	RETVAL;
	dXSTARG;
	Crypt__OpenSSL__Bignum	self;

	if (sv_derived_from(ST(0), "Crypt::OpenSSL::Bignum")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__OpenSSL__Bignum,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not of type Crypt::OpenSSL::Bignum");
#line 420 "Bignum.xs"
    checkOpenSslCall( RETVAL = PTR2IV(BN_dup(self)) );
#line 1342 "Bignum.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__Bignum__CTX_new); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__Bignum__CTX_new)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Crypt::OpenSSL::Bignum::CTX::new(CLASS)");
    {
	Crypt__OpenSSL__Bignum__CTX	RETVAL;
#line 429 "Bignum.xs"
        RETVAL = BN_CTX_new();
#line 1359 "Bignum.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Crypt::OpenSSL::Bignum::CTX", (void*)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Crypt__OpenSSL__Bignum__CTX_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS(XS_Crypt__OpenSSL__Bignum__CTX_DESTROY)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: Crypt::OpenSSL::Bignum::CTX::DESTROY(self)");
    {
	Crypt__OpenSSL__Bignum__CTX	self;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Crypt__OpenSSL__Bignum__CTX,tmp);
	}
	else
	    Perl_croak(aTHX_ "self is not a reference");
#line 436 "Bignum.xs"
        BN_CTX_free(self);
#line 1384 "Bignum.c"
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_Crypt__OpenSSL__Bignum); /* prototype to pass -Wmissing-prototypes */
XS(boot_Crypt__OpenSSL__Bignum)
{
    dXSARGS;
    char* file = __FILE__;

    XS_VERSION_BOOTCHECK ;

        newXS("Crypt::OpenSSL::Bignum::DESTROY", XS_Crypt__OpenSSL__Bignum_DESTROY, file);
        newXS("Crypt::OpenSSL::Bignum::new_from_word", XS_Crypt__OpenSSL__Bignum_new_from_word, file);
        newXS("Crypt::OpenSSL::Bignum::new_from_decimal", XS_Crypt__OpenSSL__Bignum_new_from_decimal, file);
        newXS("Crypt::OpenSSL::Bignum::new_from_hex", XS_Crypt__OpenSSL__Bignum_new_from_hex, file);
        newXS("Crypt::OpenSSL::Bignum::new_from_bin", XS_Crypt__OpenSSL__Bignum_new_from_bin, file);
        newXS("Crypt::OpenSSL::Bignum::new", XS_Crypt__OpenSSL__Bignum_new, file);
        newXS("Crypt::OpenSSL::Bignum::zero", XS_Crypt__OpenSSL__Bignum_zero, file);
        newXS("Crypt::OpenSSL::Bignum::one", XS_Crypt__OpenSSL__Bignum_one, file);
        newXS("Crypt::OpenSSL::Bignum::rand", XS_Crypt__OpenSSL__Bignum_rand, file);
        newXS("Crypt::OpenSSL::Bignum::pseudo_rand", XS_Crypt__OpenSSL__Bignum_pseudo_rand, file);
        newXS("Crypt::OpenSSL::Bignum::rand_range", XS_Crypt__OpenSSL__Bignum_rand_range, file);
        newXS("Crypt::OpenSSL::Bignum::bless_pointer", XS_Crypt__OpenSSL__Bignum_bless_pointer, file);
        newXS("Crypt::OpenSSL::Bignum::to_decimal", XS_Crypt__OpenSSL__Bignum_to_decimal, file);
        newXS("Crypt::OpenSSL::Bignum::to_hex", XS_Crypt__OpenSSL__Bignum_to_hex, file);
        newXS("Crypt::OpenSSL::Bignum::to_bin", XS_Crypt__OpenSSL__Bignum_to_bin, file);
        newXS("Crypt::OpenSSL::Bignum::get_word", XS_Crypt__OpenSSL__Bignum_get_word, file);
        newXS("Crypt::OpenSSL::Bignum::is_zero", XS_Crypt__OpenSSL__Bignum_is_zero, file);
        newXS("Crypt::OpenSSL::Bignum::is_one", XS_Crypt__OpenSSL__Bignum_is_one, file);
        newXS("Crypt::OpenSSL::Bignum::is_odd", XS_Crypt__OpenSSL__Bignum_is_odd, file);
        newXS("Crypt::OpenSSL::Bignum::add", XS_Crypt__OpenSSL__Bignum_add, file);
        newXS("Crypt::OpenSSL::Bignum::sub", XS_Crypt__OpenSSL__Bignum_sub, file);
        newXS("Crypt::OpenSSL::Bignum::mul", XS_Crypt__OpenSSL__Bignum_mul, file);
        newXS("Crypt::OpenSSL::Bignum::div", XS_Crypt__OpenSSL__Bignum_div, file);
        newXS("Crypt::OpenSSL::Bignum::sqr", XS_Crypt__OpenSSL__Bignum_sqr, file);
        newXS("Crypt::OpenSSL::Bignum::mod", XS_Crypt__OpenSSL__Bignum_mod, file);
        newXS("Crypt::OpenSSL::Bignum::mod_mul", XS_Crypt__OpenSSL__Bignum_mod_mul, file);
        newXS("Crypt::OpenSSL::Bignum::exp", XS_Crypt__OpenSSL__Bignum_exp, file);
        newXS("Crypt::OpenSSL::Bignum::mod_exp", XS_Crypt__OpenSSL__Bignum_mod_exp, file);
        newXS("Crypt::OpenSSL::Bignum::mod_inverse", XS_Crypt__OpenSSL__Bignum_mod_inverse, file);
        newXS("Crypt::OpenSSL::Bignum::gcd", XS_Crypt__OpenSSL__Bignum_gcd, file);
        newXS("Crypt::OpenSSL::Bignum::equals", XS_Crypt__OpenSSL__Bignum_equals, file);
        newXS("Crypt::OpenSSL::Bignum::cmp", XS_Crypt__OpenSSL__Bignum_cmp, file);
        newXS("Crypt::OpenSSL::Bignum::num_bits", XS_Crypt__OpenSSL__Bignum_num_bits, file);
        newXS("Crypt::OpenSSL::Bignum::num_bytes", XS_Crypt__OpenSSL__Bignum_num_bytes, file);
        newXS("Crypt::OpenSSL::Bignum::rshift", XS_Crypt__OpenSSL__Bignum_rshift, file);
        newXS("Crypt::OpenSSL::Bignum::lshift", XS_Crypt__OpenSSL__Bignum_lshift, file);
        newXS("Crypt::OpenSSL::Bignum::ucmp", XS_Crypt__OpenSSL__Bignum_ucmp, file);
        newXS("Crypt::OpenSSL::Bignum::swap", XS_Crypt__OpenSSL__Bignum_swap, file);
        newXS("Crypt::OpenSSL::Bignum::copy", XS_Crypt__OpenSSL__Bignum_copy, file);
        newXS("Crypt::OpenSSL::Bignum::pointer_copy", XS_Crypt__OpenSSL__Bignum_pointer_copy, file);
        newXS("Crypt::OpenSSL::Bignum::CTX::new", XS_Crypt__OpenSSL__Bignum__CTX_new, file);
        newXS("Crypt::OpenSSL::Bignum::CTX::DESTROY", XS_Crypt__OpenSSL__Bignum__CTX_DESTROY, file);

    /* Initialisation Section */

#line 32 "Bignum.xs"
    ERR_load_crypto_strings();

#line 1448 "Bignum.c"

    /* End of Initialisation Section */

    XSRETURN_YES;
}

